COLLECTION_NAME_bpr_item_recs, a BPR Recommender job is already created and configured to produce items-for-user recommendations.
This is the recommended job type, and produces better results with a short runtime. To create the query pipeline that consumes this job’s output, see Fetch Items-for-User Recommendations (Collaborative/BPR Method).
Fetch Items-for-User Recommendations (Collaborative/BPR Method)
Fetch Items-for-User Recommendations (Collaborative/BPR Method)
In Fusion you can download and import a query pipeline that works out of the box to fetch items-for-user recommendations generated by the default BPR Recommender job.There are two separate pipelines attached below which work in different ways to query and return recommendations.Query for recommendations onlySee also
-
Download the
APPName_item_user_rec_pipelines_bpr.jsonfile. -
Rename the file to replace
APPNamewith the name of your Fusion app, such asProductCatalog_item_user_rec_pipelines_bpr.json. -
Open the JSON file, replace all instances of
APPNamewith the name of your Fusion app, such asProductCatalog, and save it. -
Import the JSON file into your Fusion instance using the Query Pipelines REST API:
-
In the Fusion UI, navigate to Query > Query Pipelines to verify that the new pipeline is available.
This pipeline should be used to query the collection where the recommendations are stored. It makes a query against the
userIdfield and only returns the recommendeditemIdvalues. To get the actual items, you need to make a second query to the respective catalog collection with the returneditemIdvalues.
-
Download the
APPName_items_for_user_bpr_boost.jsonfile - Rename the file to replace
APPNamewith the name of your Fusion app, such asProductCatalog_items_for_user_bpr_boost.json. - Open the JSON file, replace all instances of
APPNamewith the name of your Fusion app, such asProductCatalog. - Fill in the
collectionname field in the firstRecommend Items for Userstage and save the file. - Import the JSON file into your Fusion instance using the Query Pipelines REST API:
- In the Fusion UI, navigate to Query > Query Pipelines to verify that the new pipeline is available.
This pipeline queries the recommendations collection and then makes a subsequent query to the actual catalog collection boosting the recommended items and returning the actual items from the catalog. This pipeline will therefore also return recommendations even if none were generated/available.
This pipeline expects a request parameter called
id=<userId> to be appended to the request in order to work. An example query URL to this pipeline would look like https://example-recs-fusion.com/api/query-pipelines/APPName_items_for_user_bpr_boost/collections/catalog/select?q=**:**&id=SomeUserId